

#include "../Exceptions/Errno.hh"
#include "../Exceptions/OS_Errno.hh"
#include <sys/types.h>
#include <sys/wait.h>
#include "t/main.hh"

using namespace std;
using namespace fatalmind;


void TEST_constructor_1() {
        class Errno ero = Errno(OS_EPERM);

		assertEqual(ero.os_errno(), OS_EPERM);
}

void TEST_constructor_2() {
        int status;
        wait(&status);
        class Errno ero = Errno();

		assertEqual(ero.os_errno(), OS_ECHILD);
}

void TEST_message_1() {
        class Errno er = Errno(OS_EPERM);
        string str1;
        char *str2;

        str1 = er.message();
        str2 = strerror(OS_EPERM);
		assertEqualT(string, str1, str2);
}

void TEST_throw_Errno_catch_Errno_1() {
        try {
                throw  Errno();
        }
        catch (Errno) {
                return;
        }
        catch (...) {
			assertNotReach();
        }
		assertNotReach();
}

void TEST_EPERM_1() {
        class Errno::EPERM eperm;

		assertEqual(eperm.os_errno(), OS_EPERM);
}

void TEST_throw_EPERM_catch_Errno_1() {
        try {
                throw  Errno::EPERM();
        }
        catch (Errno) {
                return;
        }
        catch (...) {
			assertNotReach();
        }
		assertNotReach();
}

void TEST_throw_EPERM_catch_EPERM_1() {
        try {
                throw  Errno::EPERM();
        }
        catch (Errno::EPERM) {
                return;
        }
        catch (...) {
			assertNotReach();
        }
		assertNotReach();
}

void TEST_throw_EPERM_dont_catch_ECHILD_but_Errno_1() {
        try {
                throw  Errno::EPERM();
        }
        catch (Errno::ECHILD) {
			assertNotReach();
        }
        catch (Errno) {
                return;
        }
        catch (...) {
			assertNotReach();
        }
		assertNotReach();
}

void TEST_real_throw_catch_example___throw_Errno_Catch_ECHILD() {
        int status;
        try {
                if (wait(&status) == -1) {
                        Errno::Throw();
                }
        }
        catch (Errno::ECHILD) {
                return;
        }
        catch (Errno) {
				assertNotReach();
        }
        catch (...) {
				assertNotReach();
        }
		assertNotReach();
}


