//********************************************************************
//*** Thread/LockStaisticsFwd.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: LockStatisticsFwd.hh,v 1.8 2008/01/27 16:42:29 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef INCLUDED_THREAD_LOCKSTATISTICSFWD_HH
#define INCLUDED_THREAD_LOCKSTATISTICSFWD_HH
#endif

#include <iosfwd>

namespace fatalmind {
	template<class UsagePattern, class TimingPattern>
	class LockStatistics;

	template<class UsagePattern, class TimingPattern>
	std::ostream& operator<<(std::ostream& o
		, const LockStatistics<UsagePattern, TimingPattern> & ls);


	class NopLockUsageStatistics;
	std::ostream& operator<<(std::ostream& o, const NopLockUsageStatistics&);
	class LockUsageStatistics;
	std::ostream& operator<<(std::ostream& o, const LockUsageStatistics&);

	class NopLockTimingStatistics;	
	std::ostream& operator<<(std::ostream& o, const NopLockTimingStatistics&);
	class LockTimingStatistics;
	std::ostream& operator<<(std::ostream& o, const LockTimingStatistics&);

	typedef LockStatistics<NopLockUsageStatistics, NopLockTimingStatistics> 
		DefaultLockStatistics;

	typedef DefaultLockStatistics NopLockStatistics;

	typedef LockStatistics<LockUsageStatistics, NopLockTimingStatistics> 
		UsageOnlyLockStatistics;

	typedef LockStatistics<NopLockUsageStatistics, LockTimingStatistics> 
		TimingOnlyLockStatistics;

	typedef LockStatistics<LockUsageStatistics, LockTimingStatistics> 
		FullLockStatistics;


}
