//********************************************************************
//*** util/Clone.cc
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: Clone.cc,v 1.3 2008/01/27 16:42:29 mws Exp $
//********************************************************************

#ifndef UTIL_CLONE_HH
#include "util/Clone.hh"
#endif

#include <sstream>

namespace fatalmind {

CloneException::CloneException(const Clone* const t1)
: Exception(getCloneErrorMessage(t1))
{
}
		
std::string CloneException::getCloneErrorMessage(const Clone* const t1) {
	std::ostringstream oss;
		
	oss << "DoClone function not properly overwritten for " << typeid(*t1).name();
	return oss.str();
}

} // namespace fatalmind

